﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;


namespace OrthoRef
{
    public partial class Form1 : Form
    {
        
       public Form1()
        {
            InitializeComponent();
        }

        public dsGCP dsGCPData
        {
            get
            {
                return dsGCP;
            }
        }


        private void tsbOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "Image files|*.BMPC;*.JPGC;*.TIFC;*.GIFC";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                this.zoomPicBox1.Image = Image.FromFile(dlg.FileName);
                this.zoomPicBox1.ZoomExtents();
                toolStripStatusLabel3.Text = "Zoom: " + (int)(zoomPicBox1.Zoom * 100) + "% ";
            }
        }
        private void tsbSave_Click(object sender, EventArgs e)
        {
           if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                dsGCP.tlbGCP.WriteXml(saveFileDialog1.FileName);
            }
         }


        private void tsbZoomIn_Click(object sender, EventArgs e)
        {
            zoomPicBox1.Zoom *= 1.2f;
            toolStripStatusLabel3.Text = "Zoom: " + (int) (zoomPicBox1.Zoom * 100) + "% ";
        }

        private void tsbZoomOut_Click(object sender, EventArgs e)
        {
            zoomPicBox1.Zoom /= 1.2f;
            toolStripStatusLabel3.Text = "Zoom: " + (int)(zoomPicBox1.Zoom * 100) + "% ";
        }

        private void tsbZoomExtends_Click(object sender, EventArgs e)
        {
            zoomPicBox1.ZoomExtents();
            
            toolStripStatusLabel3.Text = "Zoom: " + (int)(zoomPicBox1.Zoom * 100) + "% ";
        }

        private void tsbZoom11_Click(object sender, EventArgs e)
        {
            zoomPicBox1.Zoom = 1f;
            toolStripStatusLabel3.Text = "Zoom: " + (int)(zoomPicBox1.Zoom * 100) + "% ";
        }
        
        private void zoomPicBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (tsbAddPoint.Checked == true)
            {
                Point pt = zoomPicBox1.BacktrackMouse(e);
                pt.X -= zoomPicBox1.Image.Width / 2;
                pt.Y -= zoomPicBox1.Image.Height / 2;
             
                DataRow row;
                
                row = dsGCP.tlbGCP.NewRow();
                row["ImageX"] = pt.X;
                row["ImageY"] = pt.Y;

                dsGCP.tlbGCP.Rows.Add(row);
            }
            
        }

        private void zoomPicBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (zoomPicBox1.Image != null)
            {

                Point pt = zoomPicBox1.BacktrackMouse(e);

                //Center point coordinates (0,0)
                pt.X -= zoomPicBox1.Image.Width / 2;
                pt.Y -= zoomPicBox1.Image.Height / 2;
                toolStripStatusLabel1.Text = "X: " + pt.X.ToString();
                toolStripStatusLabel2.Text = "Y: " + pt.Y.ToString();
            }
        }

        private void zoomPicBox1_MouseLeave(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "X: ";
            toolStripStatusLabel2.Text = "Y: ";
        }
        
        private void tsbAbout_Click(object sender, EventArgs e)
        {
            Form AboutBox = new AboutBox1();
            AboutBox.ShowDialog();
        }
             
        
        private void tsbAddPoint_Click_1(object sender, EventArgs e)
        {
            tsbAddPoint.Checked = !tsbAddPoint.Checked;
            addPointsToolStripMenuItem.Checked = !addPointsToolStripMenuItem.Checked;
            if (tsbAddPoint.Checked == true)
                
                zoomPicBox1.Cursor = Cursors.Cross;

            else
                zoomPicBox1.Cursor = DefaultCursor;
            
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void zoomPicBox1_Paint(object sender, PaintEventArgs e)
        {
            Pen blackPen = new Pen(Color.Black, 2);
            
           
            foreach(DataRow row in dsGCP.tlbGCP.Rows)
            {
                try
                {

                    int x = Convert.ToInt16(row["ImageX"]);
                    int y = Convert.ToInt16(row["ImageY"]);
                    e.Graphics.DrawLine(blackPen, x - 5, y, x + 5, y);
                    e.Graphics.DrawLine(blackPen, x, y - 5, x, y + 5);
                }
                catch
                {
                    MessageBox.Show("Blank cells not allowed");
                    return;
                }
               
             
            }
            zoomPicBox1.Invalidate();
           
            
            
        }

        private void tsmFile_Click(object sender, EventArgs e)
        {

        }
   }
}